#include <nspireio.h>
#include <stdio.h>
#include <os.h>
#include <libndls.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "images.h"
#include "n2DLib.h"

#define M_PI 3.14159265358979323846

#define K_ESC isKeyPressed(KEY_NSPIRE_ESC)
#define K_ENTER isKeyPressed(KEY_NSPIRE_ENTER)
#define K_TAB isKeyPressed(KEY_NSPIRE_TAB)
#define K_A isKeyPressed(KEY_NSPIRE_A)
#define K_7 isKeyPressed(KEY_NSPIRE_7)
#define K_9 isKeyPressed(KEY_NSPIRE_9)
#define K_8 isKeyPressed(KEY_NSPIRE_8)
#define K_5 isKeyPressed(KEY_NSPIRE_5)
#define K_4 isKeyPressed(KEY_NSPIRE_4)
#define K_6 isKeyPressed(KEY_NSPIRE_6)

#define COLOR_BPP		   16
#define COLOR_STORAGE_SIZE 2
#define BMPWIDTH		   17;
#define BMPHEIGHT		   12;

#define shift_y 8
#define shift_x 8
#define vy_limit 256
#define vx_limit 256
#define maxtrail 20

void FillScreen565(unsigned short c) {
	int x; int y;
	for(y=0;y<240;y++) {
		for(x=0;x<320;x++) {
			setPixel(x,y,c);
		}
	}
}

void DrawCenteredNum(int x, int y, int n, unsigned short* font) {
	int stringwidth=log10(n)+1;
	int fontw=font[0];
	int fonth=font[1];
	x=x+stringwidth*(fontw-1)/2;
	y=y-fonth/2;
	int p,i,j;
	unsigned short c;
	while(n) {
		p=(n%10)*fontw*fonth+2;
		for(j=0;j<fonth;j++) {
			for(i=0;i<fontw;i++) {
				c=font[++p];
				if(c!=font[2]) {
					setPixel(x+i,y+j,c);
				}
			}
		}
		x=x-fontw;
		n=n/10;
	}
}

void EraseCenteredNum(int x, int y, int n, unsigned short* font) {
	int stringwidth=log10(n)+1;
	int fontw=font[0];
	int fonth=font[1];
	x=x+stringwidth*(fontw-1)/2;
	y=y-fonth/2;
	int p,i,j;
	unsigned short c;
	while(n) {
		p=(n%10)*fontw*fonth+2;
		for(j=0;j<fonth;j++) {
			for(i=0;i<fontw;i++) {
				c=font[++p];
				if(c!=font[2]) {
					setPixel(x+i,y+j,0); //seule ligne qui change par rapport  Draw
				}
			}
		}
		x=x-fontw;
		n=n/10;
	}
}

/*---------------------------------------------*/
/*               Le Vrai Code                  */
/*---------------------------------------------*/
typedef struct {
	int x;
	int y;
} Point;
typedef struct {
	int x;
	int y;
	int vx;
	int vy;
	int active;
	int angle;
} bullet;

typedef struct {
	int x;
	int y;
} green;

void initialiserFichier(void) {
	FILE* fp=NULL;
	fp=fopen("JetpackImpossible.dat","bw+");
	if(fp!=NULL) {
		fputc('0', fp);
		//fprintf(fp,"%d",0);
		fclose(fp);
	}else{
		show_msgbox("Erreur","Erreur d'initialisation de fichier");
		while(K_ENTER);
	}
}

void setHighscore(const unsigned int s) {
	FILE* fp=NULL;
	fp=fopen("JetpackImpossible.dat","bw+");
	if(fp!=NULL) {
		fprintf(fp, "%d", s);
		fclose(fp);
	}else{
		show_msgbox("Erreur","Erreur d'criture de fichier");
		while(K_ENTER);
	}
}

int getHighscore(void) {
	char txt[5];
	int s;
	FILE* fp=NULL;
	fp=fopen("JetpackImpossible.dat","br");
	if(fp!=NULL) {
		fgets(txt, 5, fp);
		sscanf(txt, "%u", &s);
		fclose(fp);
		return s;
	}else{
		show_msgbox("Erreur","Erreur de lecture de fichier");
		while(K_ENTER);
		return 1;
	}
}

int main(int argc,char* argv[]) {
	//int main(void){
	//nSDL_EnableRelativePaths(argv); //on a besoin de a si on met des bmps  charger dans le dossier
	
	//initDoubleBuff();
	initBuffering();
	enable_relative_paths(argv);
	FILE* fp=NULL;
	fp=fopen("JetpackImpossible.dat","r");
	if(fp==NULL) {
		initialiserFichier();
	}else{
		fclose(fp);
	}
	
	//char score_txt[5]={"0"};
	
	drawSprite(Title,0,0);
	int high=getHighscore();
	//sprintf(score_txt,"%d",high);
	//nSDL_DrawStringCF(screen,scoreFont_mini,SCREEN_WIDTH/2-nSDL_GetStringWidth(scoreFont_mini,score_txt)/2,175,score_txt);
	DrawCenteredNum(SCREEN_WIDTH/2, 175, high, chiffres);
	
	//switchBuffers();
	updateScreen();
	
	while(!(K_ENTER||K_ESC||K_TAB));
	
	//int slp=(int)argv[1]; //sert juste  enlever le warning
	int slp=1;
	if(K_TAB) {
		slp=0;
	}
	
	unsigned short* Jill=JillD;
	unsigned short* Jill_shadow=JillD_shadow;
	
	bullet* bullets=malloc(13*sizeof(bullet));
	green* greens=malloc(3*sizeof(green));
	Point* trail=malloc(maxtrail*sizeof(Point));

	Rect* sr; //sert  dessiner des sprites rotates
	
	int i=argc; //utilis dans les boucles for
	//initialis  argc pour rien, juste pour enlever l'avertissement "unused parameter 'argc'"

	int keep_playing=1;
	while(keep_playing) {
		FillScreen565(0);
		for(i=0;i<13;i++) {
			bullets[i].x=(rand()%320)*512;
			bullets[i].y=(rand()%240)*512;
			int rad=rand();
			bullets[i].vx=fixcos(rad);
			bullets[i].vy=fixsin(-rad);
			bullets[i].active=0;
			bullets[i].angle=rad;
		}
		for(i=0;i<3;i++) {
			greens[i].x=rand()%320;
			greens[i].y=rand()%240;
		}
		for(i=0;i<maxtrail;i++) {
			trail[i].x=-20;
		}
		int alive=1;
		int pause=1;
		int score=0;
		int x=SCREEN_WIDTH/2<<shift_x;
		int y=SCREEN_HEIGHT/2<<shift_y;
		int vx=0;
		int vy=0;
		int currenttrail=0;
		int trailon;
		while(K_7||K_9);
		//on attend que l'utilisateur lche les touches avant de commencer
		//sinon il risque de dcoller sans le vouloir dans la nouvelle partie
		//(surtout qi ce n'est pas la premire partie)
		while(keep_playing&&alive) {
			//sprintf(score_txt,"%d",score);
			for(i=0;i<13;i++) {
				sr->x=bullets[i].x/512; sr->y=bullets[i].y/512;
				drawSpriteRotated(Fire_shadow, sr, bullets[i].angle);
				int xt=bullets[i].x+bullets[i].vx;
				int yt=bullets[i].y+bullets[i].vy;
				if(xt<0) {xt=320*512;bullets[i].active=1;}
				if(xt>320*512) {xt=0;bullets[i].active=1;}
				if(yt<0) {yt=240*512;bullets[i].active=1;}
				if(yt>240*512) {yt=0;bullets[i].active=1;}
				//c'est des moins dans tous les cas (mme 320-wb et pas 320+wb) car
				//xt,yt sont les coordonnes du coin haut gauche, pas du milieu
				bullets[i].x=xt;
				bullets[i].y=yt;
				if(bullets[i].active) {
					sr->x=xt/512; sr->y=yt/512;
					drawSpriteRotated(Fire, sr, bullets[i].angle);
				}
				if((abs((x>>shift_x)-xt/512)<3+8) && (abs((y>>shift_y)-yt/512)<3+6) && (score>0) && (bullets[i].active)) {
					//les "3+" aprs les "<" sont la taille des mtores sans compter la trail
					//le reste (8 et 6) reprsente la moiti de la dimension de Jill dan la direction concerne
					alive=0;
				}
			}
			for(i=0;i<3;i++) {
				if((abs((x>>shift_x)-greens[i].x)<11) && (abs((y>>shift_y)-greens[i].y)<9)) {
					drawSprite(Green_shadow,greens[i].x,greens[i].y);
					EraseCenteredNum(SCREEN_WIDTH/2, 50, score, chiffres);
					score++;
					greens[i].x=rand()%320;
					greens[i].y=rand()%240;
				}
				drawSprite(Green,greens[i].x,greens[i].y);
			}
			DrawCenteredNum(SCREEN_WIDTH/2, 50, score, chiffres);
			int oldx=x; int oldy=y; int oldvx=vx; unsigned short* oldJill_shadow=Jill_shadow;
			if(K_7 || K_9) {
				//acclration vers le haut
				trailon=1;
				vy-=6;
				if(vy<-vy_limit) {vy=-vy_limit;}
				if(K_7) {
					//acclration vers la gauche
					Jill=JillG;
					Jill_shadow=JillG_shadow;
					vx=vx-7;
					if(vx<-vx_limit) {vx=-vx_limit;}
				}
				if(K_9) {
					//acclration vers la droite
					Jill=JillD;
					Jill_shadow=JillD_shadow;
					vx=vx+7;
					if(vx>vx_limit) {vx=vx_limit;}
				}
			}else{
				//gravit et frottements
				trailon=0;
				if(vy<vy_limit) {vy+=4;};
				vx=(vx<0)-(vx>0)+vx;
			}
			y+=vy;
			x+=vx;
			if(x>>shift_x<(-8)) {x=(320-8)<<shift_x;}
			if(x>>shift_x>320-8) {x=-8<<shift_x;}
			if(y>>shift_y<(-8)) {y=(240-8)<<shift_y;}
			if(y>>shift_y>240-8) {y=-8<<shift_y;}
			
			//on doit tout redessiner  cause de Jill_shadow
			//mieux: ne pas faire des pixels pour tout le monde mais des plus gros quand ils sont plus proches de Jill
			for(i=0;i<maxtrail;i++) {
				int j=(currenttrail+i)%maxtrail;
				int ixmax=i*4/maxtrail;
				int ix;
				for(ix=-ixmax/2;ix<=ixmax/2;ix++) {
					setPixelRGB(trail[j].x+ix,trail[j].y,0,0,0);
				}
			}
			currenttrail=(currenttrail+1)%maxtrail;
			if(trailon) {
				trail[currenttrail].x=(x>>shift_x)-(Jill==JillD?8:-8);
				trail[currenttrail].y=y>>shift_y;
			}else{
				trail[currenttrail].x=-20;
			}
			for(i=0;i<maxtrail;i++) {
				int j=(currenttrail+i)%maxtrail;
				int ixmax=i*4/maxtrail;
				int ix;
				for(ix=-ixmax/2;ix<=ixmax/2;ix++) {
					setPixelRGB(trail[j].x+ix,trail[j].y,255,i*255/maxtrail,0);
				}
			}
			
			sr->x=oldx>>shift_x; sr->y=oldy>>shift_y;
			drawSpriteRotated(oldJill_shadow, sr, -oldvx*32/vx_limit);
			sr->x=x>>shift_x; sr->y=y>>shift_y;
			drawSpriteRotated(Jill, sr, -vx*32/vx_limit);
			
			//switchBuffersRestore();
			updateScreen();
			clearBufferB();
			if(K_TAB) {pause=1;}
			if(pause) {
				while(!(K_7||K_9||K_ESC));
				pause=0;
			}
			if(K_ESC) {
				keep_playing=0;
			}
			if(slp) {
				sleep(2);
				//changer en 2 avant de compiler pour calculette, et mettre 3 pour l'emu
			}
		}
		if(getHighscore()<score) {
			//afficher "nouveau highscore"
			setHighscore(score);
		}
	}
	free(greens);
	free(bullets);
	free(trail);
	
	deinitBuffering();
	return 0;
}


